<?php

// This file is part of Moodle - http://moodle.org/
//
// Moodle is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
//
// Moodle is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with Moodle.  If not, see <http://www.gnu.org/licenses/>.

/**
 * Strings for component 'theme_brick', language 'en', branch 'MOODLE_20_STABLE'
 *
 * @package   moodlecore
 * @copyright 2010 Patrick Malley
 * @license   http://www.gnu.org/copyleft/gpl.html GNU GPL v3 or later
 */

$string['pluginname'] = 'Brick';
$string['region-side-post'] = 'Right';
$string['region-side-pre'] = 'Left';
$string['choosereadme'] = '<div class="clearfix">

<div class="theme_screenshot">

	<h2 style="padding-top:0.5em;">Brick</h2>
	<img src="brick/pix/screenshot.png" />

	<h3>Theme Discussion Forum:</h3>
	<p><a href="http://moodle.org/mod/forum/view.php?id=46">http://moodle.org/mod/forum/view.php?id=46</a></p>

	<h3>Theme Documentation:</h3>
	<p><a href="http://docs.moodle.org/en/Themes">http://docs.moodle.org/en/Themes</a></p>

	<h3>Theme Credits</h3>
	<p><a href="http://docs.moodle.org/en/Theme_credits">http://docs.moodle.org/en/Theme_credits</a></p>

	<h3>Report a bug:</h3>
	<p><a href="http://tracker.moodle.org">http://tracker.moodle.org</a></p>

</div>
<div class="theme_description">

	<h2>About</h2>
	<p>Brick is a two-column, fluid-width theme for Moodle 2.0. You can change the theme color scheme via the theme settings page.</p>

	<h2>Tweaks</h2>
	<p>This theme is built upon both Base and Canvas, two parent themes included in the Moodle core. If you wish to modify aspects of this theme beyond the settings offered, we advise creating a new theme that uses this theme, Base, and Canvas all as parents. This will ensure updates to any of those themes in the core will find their way into your new theme.</p>

	<h2>Credits</h2>
	<p>This theme was coded and is maintained by John Stabinger of NewSchool Learning. He can be contacted by email at contact@newschoollearning.com. </p>

	<h2>License</h2>
	<p>This, and all other themes included in the Moodle core, are licensed under the <a href="http://www.gnu.org/licenses/gpl.html">GNU General Public License</a>.</p>

</div>
</div>';

$string['configtitle'] = 'Brick settings';

$string['logo'] = 'logo';
$string['logodesc'] = 'Change the logo of this theme by entering the URL to a new one (i.e., http://www.somesite/animage.png). As a reference, the default logo is 265px wide by 60px high. A transparent PNG will work best.';

$string['linkcolor'] = 'link';
$string['linkcolordesc'] = 'Set the color of links in the theme, use html hex code.';

$string['linkhover'] = 'linkhover';
$string['linkhoverdesc'] = 'Set the color of links (on hover) in the theme, use html hex code.';

$string['maincolor'] = 'maincolor';
$string['maincolordesc'] = 'Set the color hex code of the header, dock bar and other areas. Looks best as a dark or saturated color.';

$string['maincolorlink'] = 'maincolorlink';
$string['maincolorlinkdesc'] = 'Link color for menu bar and block titles.';

$string['headingcolor'] = 'headingcolor';
$string['headingcolordesc'] = 'This is the heading color for large headings (site news, my courses) and other headings.';
